require 'class_extensions' # String::normalize

class SezGuidepost < ActiveRecord::Base
  include CommonGuidepost
  extend CommonGuidepost::ClassMethods
  
  has_one :guidepost
  
  delegate :kct_guidepost, :osmid, :osm_guidepost, to: :guidepost, allow_nil: true
  delegate :kctref, to: :kct_guidepost, allow_nil: true
  
  def self.new_from_json(ajson)
    result = SezGuidepost.new
    result.initialize_from_json(ajson)
    return result
  end
  
  def initialize_from_json(ajson)
    self.nazev = ajson['properties']['TEXT1']
    self.nazev_normalized = nazev.normalize unless nazev.nil?
    self.lat = ajson['geometry']['coordinates'][1]
    self.lon = ajson['geometry']['coordinates'][0]
  end
  
  def coordinates; [lat,lon] end
  def to_s(option=nil)
    case option
      when :long then "#{nazev} sez:#{id}"
      else "sg:#{id}"
    end
  end
  def self.symbol; '&#8664;'.html_safe end  

end
